<script setup>
</script>

<script>
import jQuery from "jquery";
import Jszip from 'jszip';
import DataTable from 'datatables.net-vue3';
import DataTableLib from 'datatables.net-bs5';
import 'datatables.net-buttons-bs5';
import 'datatables.net-buttons/js/buttons.html5.mjs';
import DataTableResponsive from "datatables.net-bs5";
import axios from 'axios';
import $ from 'jquery';
import swal from 'sweetalert';
import Multiselect from '@vueform/multiselect'
import '@vueform/multiselect/themes/default.css'
// Configurar JSZip
window.JSZip = Jszip;

// Inicializar DataTables con las bibliotecas
DataTable.use(DataTableLib);
DataTable.use(DataTableResponsive);

document.addEventListener("DOMContentLoaded", function () {
  // Obtener la tabla DataTable
  const dataTable = $('#datatableLogs').DataTable();

  // Agregar un evento de clic a los elementos con la clase "eliminar" dentro de la tabla
  

  dataTable.on("click", ".detalles", function (id) {
    const rowData = dataTable.row($(this).closest("tr")).data();
    if (rowData) {
      const id = rowData.id;
      window.location.href = route('usuarios.show',id)
      console.log(id);
    }
  });


});

export default {
  components: { DataTable, Multiselect },
  data() {
    return {
      products: null,

    
      columns: [
        { data: null, render: function (data, type, row, meta) { return `${meta.row + 1}` } },
        { data: 'descripcion' },
        { data: 'modulo' }, // Modifica esta línea
        { data: 'usuario.nombreCompleto' },
        {
  data: 'logeable.rfc',
  
  render: function (data, type, row) {

    if (data != null) {
      return "El RFC que se consulto fue el  " + data
    } else if (row.logeable?.expediente != null) {
      return "El expediente modificado fue el " + row.logeable.expediente;
    } 

    else if (row.logeable?.sancion?.expediente != null) {
      return "El expediente modificado fue el " + row.logeable.sancion.expediente;
    }

    else if (row.logeable?.particular?.rfc != null) {
      return "El RFC que se modifico informacion fue " + row.logeable.particular.rfc;
    }
    
    else {
      // Agrega aquí cualquier otra condición que desees
      return row.accion; // Valor por defecto si no se cumple ninguna condición
    }
  }
},
{
  data: 'created_at',
  render: function(data, type, row) {
    if (type === 'display' || type === 'filter') {
      const createdAt = new Date(data);
      const formattedDate = createdAt.toLocaleString(); // Otra opción: createdAt.toLocaleDateString() + ' ' + createdAt.toLocaleTimeString();
      return formattedDate;
    }
    return data;
  }
},
        
      ],
      botones: [
        {
          title: 'Reporte de bitacora de actividades',
          extend: 'excelHtml5',
          text: '<i class ="far fa-file-excel"></i> Descargar Excel',
          className: 'btn btn-success',
          exportOptions: {
        columns: [1,2, 3, 4,5] // Índices de las columnas a exportar (ajusta esto según tus necesidades)
    }
        }
      ]
    }
  },

  mounted() {
    const dataTable = $('#datatableLogs').DataTable();
    this.getProducts();
    this.initDataTable();

    
  },

  props: {
	    variables: Object,
	},

  watch: {
	 
   

 },

  methods: {
    getProducts() {
      swal({
    icon: 'info',
    text: 'Cargando registros...',
    buttons: false,
    closeOnClickOutside: false,
    closeOnEsc: false,
  });
      axios.get(route('logs.get.all')).then(
        response => {
          console.log(response.data.data)
          this.products = response.data.data
          swal.close();
        }
      )
    },
    filtroBusqueda() {

      swal({
    icon: 'info',
    text: 'Cargando registros...',
    buttons: false,
    closeOnClickOutside: false,
    closeOnEsc: false,
  });

  axios.get(route('particulares.get.all.sancionados', {rfc:this.rfc,institucionesIds:this.InstitucionesIds,tiposFaltaIds:this.faltaIds,responsablesSancionIds:this.responsableSancionIds,tiposSancionIds:this.sancionesIds,fechaInicial:this.fechaInicial,fechaFinal:this.fechaFinal,rango:this.rango}))
   .then(response => {
    console.log(response.data)
     this.products = response.data
    swal.close();




   })
   .catch(error => {

    console.log(error)

     
   

    swal("Error en el filtrado", {
             icon: "error"
           });
   });
 
},

initDataTable() {
    const dataTable = $('#datatableLogs').DataTable({

      dom: 'Bfrtip', // Agrega el contenedor de botones
    buttons: [
      {
        extend: 'excelHtml5', // Extensión para exportar a Excel
        title: 'Reporte de bitacora de actividades', // Título del archivo Excel
        text: '<i class ="mdi mdi-file-excel"></i> Descargar Excel',
        className: 'btn btn-success',
        exportOptions: {
        columns: [1,2, 3, 4,5] // Índices de las columnas a exportar (ajusta esto según tus necesidades)
    }
      },
    ],
      destroy: true,
      serverSide: true,
      ajax: {
        url: route('logs.get.all'),
        type: 'GET',
        dataSrc: function (json) {
            json.recordsTotal = json.total;
            json.recordsFiltered = json.total;
            return json.data;
        },
        data: d => {
          d.page = (d.start / d.length) + 1;
        },
      },
      columns: this.columns,

      searching: true,

      
      

      language: {
          processing: "Procesando...",
          search: "Buscar:",
          lengthMenu: "Mostrar _MENU_ registros",
          info: "Mostrando desde _START_ al _END_ de _TOTAL_ registros",
          infoEmpty: "Mostrando ningún elemento.",
          infoFiltered: "(filtrado _MAX_ elementos total)",
          infoPostFix: "",
          loadingRecords: "Cargando registros...",
          zeroRecords: "No se encontraron registros",
          emptyTable: "No hay datos disponibles en la tabla",
          paginate: {
            first: "Primero",
            previous: "Anterior",
            next: "Siguiente",
            last: "Último"
          },
          aria: {
            sortAscending: ": activar para ordenar la columna ascendente",
            sortDescending: ": activar para ordenar la columna descendente"
          }
        },
      
    });
    
    dataTable.on('page.dt', () => {
      swal({
        icon: 'info',
        text: 'Cargando registros...',
        buttons: false,
        closeOnClickOutside: false,
        closeOnEsc: false,
      });
    });

    

    // Añadir un event listener para el evento 'draw'.
    dataTable.on('draw.dt', () => {
      setTimeout(() => {
    swal.close();
  }, 4000);
    });
  },


  }
}
</script>

<template>
  <div class="main-content">
    <div class="page-content">
      <div class="container-fluid">
        <div class="row">
          <div class="col-lg-12">
            <div class="card">
              <div class="card-body">
                <h4 class="card-title mb-4">Bitacora de actividades</h4>
                <div class="table-responsive">
                  <DataTable :data="products" :columns="columns" id="datatableLogs" class=" table-condensed table table-bordered dt-responsive  nowrap w-100"
                    :options="{responsive:true,autoWidth:false, dom:'Bfrtip',language:{
                      search: 'Buscar', zeroRecords:'No hay registros para mostrar',
                      info:'Mostrando del _START_ a _END_ de _TOTAL_ registros',
                      infoFiltered: '(Filtrados de _MAX_ registros.)',
                      paginate:{first: 'Primero',previous:'Anterior',next:'Siguiente', last:'Último'}
                    }, buttons:botones}">
                    <thead class="table-light">
                      <tr>
                        <th style="width: 10px;">
                          <div class="form-check font-size-16 align-middle">
                            <input class="form-check-input" type="checkbox" id="transactionCheck01">
                            <label class="form-check-label" for="transactionCheck01"></label>
                          </div>
                        </th>
                        <th class="align-middle text-center" style="width: 15%;">Accion</th>
                        <th class="align-middle text-center" style="width: 15%;">Modulo</th>
                        <th class="align-middle text-center" style="width: 25%;">Usuario</th>
                        <th class="align-middle text-center" style="width: 25%;">Descripcion</th>
                        <th class="align-middle text-center" style="width: 10;">Fecha y hora de modificacion</th>
                      </tr>
                    </thead>
                    <tbody style="text-align: center; font-size: 15px;"></tbody>
                  </DataTable>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
    <footer class="footer"></footer>
  </div>
</template>

<style>
.dataTables_wrapper .dataTables_filter {
  margin-right: 10px;
}

.dataTables_filter{
  display: none;
}

#datatableLogs{
  margin-top: 10px;
}


.dt-buttons btn-group {
  background-color: red;
}

@media (min-width: 768px) {
  #TablaPrincipal_wrapper {}
}
</style>
